﻿using System;

using Android.App;
using Android.Content.PM;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using Android.OS;
using Android.Support.V4.App;
using Android;
using Android.Support.Design.Widget;
using Android.Support.V4.Content;

namespace Sample2.Droid
{
    [Activity(Label = "Sample2", Icon = "@mipmap/icon", Theme = "@style/MainTheme", MainLauncher = true, ConfigurationChanges = ConfigChanges.ScreenSize | ConfigChanges.Orientation, ScreenOrientation = ScreenOrientation.FullSensor)]
    public class MainActivity : global::Xamarin.Forms.Platform.Android.FormsAppCompatActivity
    {
        protected override void OnCreate(Bundle savedInstanceState)
        {
            TabLayoutResource = Resource.Layout.Tabbar;
            ToolbarResource = Resource.Layout.Toolbar;

            base.OnCreate(savedInstanceState);

            Xamarin.Essentials.Platform.Init(this, savedInstanceState);
            global::Xamarin.Forms.Forms.Init(this, savedInstanceState);

            var platform = Xamarin.Forms.DependencyService.Get<IPlatformInterface>();
            platform.AndroidContext = this;
            platform.AndroidResource = Resources;
            platform.AndroidUsbDevice = null;
            platform.AndroidLocalFont = Android.Graphics.Typeface.SansSerif;
            
            LoadApplication(new App());

            GetPermissions(permissions);
        }
        public override void OnRequestPermissionsResult(int requestCode, string[] permissions, [GeneratedEnum] Android.Content.PM.Permission[] grantResults)
        {
            Xamarin.Essentials.Platform.OnRequestPermissionsResult(requestCode, permissions, grantResults);

            base.OnRequestPermissionsResult(requestCode, permissions, grantResults);
        }





        static readonly String[] permissions = {
            Manifest.Permission.AccessFineLocation,
            Manifest.Permission.WriteExternalStorage,
        };
        private static readonly int PERMISSION_REQUEST_CODE = 1234;
        private void GetPermissions(String[] permissions)
        {
            if(!CheckPermissions(permissions))
            {
                RequestPermissions(permissions);
            }
            else
            {
                System.Diagnostics.Debug.WriteLine("GetPermissions : " + "Permission.Granted");
            }
        }
        private Boolean CheckPermissions(String[] permissions)
        {
            foreach (String permission in permissions)
            {
                if (ContextCompat.CheckSelfPermission(this, permission) != (int)Permission.Granted)
                {
                    return false;               // non-permission
                }
            }
            return true;
        }
        private void RequestPermissions(String[] permissions)
        {
            ActivityCompat.RequestPermissions(this, permissions, PERMISSION_REQUEST_CODE);
        }

    }
}